<?php
define('MODE_DISPLAY_FULL', 1); 
define('MODE_COMPOSE_FULL', 2); 
define('MODE_DISPLAY_MINI', 3); 
define('MODE_DISPLAY_PDA', 4); 
define('MODE_ATTACHMENT', 5); 
define('USE_PHP_PARSER', false); 
define('ALNUM_CTRL_CHARS', '0*[0-9]|0*[12][0-9]|0*3[01]|x0*1?[0-9A-F]|0*6[5-9]|0*[78][0-9]|0*90|x0*4[1-9A-F]|x0*5[0-9A]|0*9[7-9]|0*1[01][0-9]|0*12[0-2]|x0*6[1-9A-F]|x0*7[0-9A]'); 
define('CSS_FILTER_RULES', 1); 
define('SRC_FILTER_RULES', 2); 
define('ATTRIB_FILTER_RULES', 3); 
if (USE_PHP_PARSER) { 
require_once('lowLevelHtmlParser.inc'); 
} 
define('REMOVED', "Removed*By*Webmail"); 
define('REMOVED_CSS', 'removed-by-webmail'); 
define('TAB_SIZE', 8); 
define('TAB_SPACE', "        "); 
define('MAX_WORD_LENGTH' , 1000); 
define('MAX_CONTENT_LENGTH', 200000); 
define('MAX_CSS_LENGTH_TOTAL', 10000); 
define('MAX_CSS_LENGTH_RULE', 2000); 
define('ATTACHMENT_GENERIC_NAME', 'file'); 
define('ATTACHMENT_GENERIC_EXT' , '.'); 
$x_1m2 = array( 
'folder' => '', 
'uid' => '', 
'from' => '', 
'cidsShownInline' => array() 
); 
function x_1m3($x_1m4) { 
$x_1m4 = trim($x_1m4); 
if ($x_1m4 != '') { 
if ($x_1m4 == '.') { 
$x_1m4 = '_'; 
} 
elseif ($x_1m4 == '..') { 
$x_1m4 = '__'; 
} 
else { 
$x_1m4 = strtr($x_1m4, "\\/:*?<>|\"", "_________"); 
} 
if (strpos($x_1m4, '.') === false) { 
$x_1m4 .= ATTACHMENT_GENERIC_EXT; 
} 
return x_1m5($x_1m4); 
} 
else { 
return ATTACHMENT_GENERIC_NAME . ATTACHMENT_GENERIC_EXT; 
} 
} 
function x_1m6($x_1kn) { 
$x_1m7 = $x_1kn->getContentDispositionAttributes(); 
foreach ($x_1m7 as $x_1m8) { 
if (strcasecmp($x_1m8['name'], 'filename') == 0) return $x_1m8['value']; 
} 
$x_1m7 = $x_1kn->getContentTypeAttributes(); 
foreach ($x_1m7 as $x_1m8) { 
if (strcasecmp($x_1m8['name'], 'name') == 0) return $x_1m8['value']; 
} 
return false; 
} 
function x_1m9($x_1bg) { 
if (strpos($x_1bg, '{') === false || strpos($x_1bg, '}') === false || strpos($x_1bg, ':') === false) { 
return true; 
} 
$x_1ma = strlen($x_1bg); 
if ($x_1ma < MAX_CSS_LENGTH_TOTAL) { 
return false; 
} 
$x_1mb = 0; 
$x_1mc = '{'; 
while ($x_1mb < $x_1ma) { 
$x_1md = strpos($x_1bg, $x_1mc, $x_1mb); 
if ($x_1md === false) { 
$x_1md = $x_1ma; 
} 
if ($x_1md - $x_1mb > MAX_CSS_LENGTH_RULE) { 
return true; 
} 
$x_1mb = $x_1md; 
$x_1mc = ($x_1mc == '{' ? '}' : '{'); 
} 
return false; 
} 
function x_1me($x_1bg) { 
if (x_1m9($x_1bg)) { 
return ''; 
} 
$x_r = ""; 
if (preg_match_all("/\s*([^{}]+)\s*{\s*([^{}]+)\s*}/si", $x_1bg, $x_1mf)) { 
$x_1mg = count($x_1mf[1]); 
$x_r = ""; 
for ($x_1l = 0; $x_1l < $x_1mg; $x_1l++) { 
$x_r[$x_1mf[1][$x_1l]] = $x_1mf[2][$x_1l]; 
} 
} 
return $x_r; 
} 
function x_1mh($x_1mi, $x_1if) { 
$x_r = ""; 
if (is_array($x_1mi)) foreach ($x_1mi as $x_a => $x_1cn) { 
if ($x_a == "*" || strcasecmp($x_a, "body") == 0) { 
$x_a = $x_1if; 
} 
else { 
$x_a = $x_1if . " " . str_replace(",", "," . $x_1if . " ", $x_a); 
} 
$x_r[$x_a] = $x_1cn; 
} 
return $x_r; 
} 
function x_1mj($x_1mi) { 
$x_r = ""; 
if (is_array($x_1mi)) foreach ($x_1mi as $x_a => $x_1cn) { 
$x_r .= "\n " . $x_a . " {" . $x_1cn . "}"; 
} 
return $x_r; 
} 
function x_1mk($x_1ml) { 
switch ($x_1ml) { 
case CSS_FILTER_RULES: 
$x_1mm = array( 
'/expression/i' => REMOVED, 
'/res:\/\//i' => REMOVED, 
'/sysimage:\/\//i' => REMOVED, 
'/data:/i' => REMOVED, 
'/jar:/i' => REMOVED, 
'/position/i' => REMOVED_CSS, 
'/-moz-binding/i' => REMOVED_CSS 
); 
break; 
case SRC_FILTER_RULES: 
$x_1mm = array( 
'/^\s*res:\/\//i' => REMOVED, 
'/^\s*sysimage:\/\//i' => REMOVED, 
'/^\s*data:/i' => REMOVED, 
'/^\s*jar:/i' => REMOVED 
); 
break; 
} 
$x_1mm['/S\s*C\s*R\s*I\s*P\s*T\s*:/Si'] = REMOVED . ':'; 
$x_1mm['/(&#)(' . ALNUM_CTRL_CHARS . ')([^0-9A-F])/Usi'] = "\\1 \\2\\3"; 
return $x_1mm; 
} 
function x_1mn($x_1kg) { 
global $x_1m2; 
$x_1mo = strtolower(trim(substr($x_1kg, 4))); 
$x_1m2['cidsShownInline'][] = '<' . $x_1mo . '>'; 
$x_1mp = '../webmail/mailAttach.php?folder=' . urlencode($x_1m2['folder']) . '&uid=' . $x_1m2['uid'] . '&cid=' . $x_1mo; 
return $x_1mp; 
} 
function x_1mq($x_1mr, $x_1ms) { 
$x_1ki = '/url\s*\((' . ($x_1ms ? '\s*cid:' : '') . '[^\)]+)\)/Usi'; 
return preg_replace_callback($x_1ki, 'x_1mt', $x_1mr); 
} 
function x_1mt($matches) { 
$x_1x = trim($matches[1]); 
if (strtolower(substr($x_1x, 0, 4)) == 'cid:') { 
$x_1mu = 'url("' . x_1mn($x_1x) . '")'; 
} 
else { 
$x_1mu = 'none'; 
} 
return $x_1mu; 
} 
function x_1mv($x_1mr, $x_1mw, $x_1mx) { 
$x_1mr = str_replace('\\', '/', $x_1mr); 
$x_1mr = str_replace(array('/*', '*/'), REMOVED, $x_1mr); 
$x_1mr = preg_replace($x_1mw, $x_1mx, $x_1mr); 
return $x_1mr; 
} 
function x_1my($x_1mi, $x_1l1, $x_1ms) { 
$x_r = array(); 
if (is_array($x_1mi)) { 
$x_1mz = x_1mk(CSS_FILTER_RULES); 
$x_1mw = array_keys($x_1mz); 
foreach ($x_1mi as $x_a => $x_1cn) { 
$x_1cn = x_1mv($x_1cn, $x_1mw, $x_1mz); 
$x_1cn = x_1mq($x_1cn, $x_1ms); 
$x_r[$x_a] = $x_1cn; 
} 
} 
return $x_r; 
} 
function x_1n0(&$x_1ll) { 
$x_1n1 = strlen($x_1ll); 
if ($x_1n1 >= MAX_CONTENT_LENGTH) return false; 
$x_1n2 = 0; 
$x_1n3 = -1; 
while ($x_1n2 !== false && $x_1n3 < $x_1n1) { 
$x_1n3 += $x_1n2 + 1; 
$x_1n2 = strrpos(substr($x_1ll, $x_1n3, MAX_WORD_LENGTH), " "); 
} 
return ($x_1n1 - $x_1n3 <= MAX_WORD_LENGTH); 
} 
function x_1n4($x_1ll, $x_1l1) { 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
$x_1mu = '<a href="javascript:x_1n5(\'new\',\'\\1\')" onmouseover="window.status=\'\';return true;" onclick="window.status=\'\';return true;">\\1</a>'; 
$x_1n6 = ' defaultcontextmenu="yes"'; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$x_1mu = '<a href="compose.php?mailTo=\\1">\\1</a>'; 
$x_1n6 = ''; 
break; 
case MODE_COMPOSE_FULL: 
default: 
$x_1mu = '<a href="mailto:\\1">\\1</a>'; 
$x_1n6 = ''; 
break; 
} 
if (strpos($x_1ll, '://') !== false) { 
$x_1n7 = preg_split('~(https?|ftp)://~i', $x_1ll, -1, PREG_SPLIT_DELIM_CAPTURE); 
$x_1n8 = (count($x_1n7) - 1) / 2; 
$x_1ll = $x_1n7[0]; 
for ($x_1l = 0; $x_1l < $x_1n8; $x_1l++) { 
$x_a = 2 * $x_1l + 1; 
$x_1n9 = $x_1n7[$x_a] . '://'; 
$x_1na = $x_1n7[$x_a + 1]; 
if (trim($x_1na) == '') { 
$x_1ll .= $x_1n9 . $x_1na; 
continue; 
} 
$x_1na = preg_split('~\s~', $x_1na, 2); 
$x_1nb = $x_1na[0]; 
$x_1b4 = (isset($x_1na[1]) ? ' ' . $x_1na[1] : ''); 
$x_1nc = strpos($x_1nb, '&gt;'); 
$x_1nd = strpos($x_1nb, '&lt;'); 
if ($x_1nc !== false) { 
$x_1ne = ($x_1nd !== false && $x_1nd < $x_1nc) ? $x_1nd : $x_1nc; 
} 
else { 
$x_1ne = $x_1nd; 
} 
if ($x_1ne !== false) { 
$x_1nb = substr($x_1na[0], 0, $x_1ne); 
$x_1b4 = substr($x_1na[0], $x_1ne) . $x_1b4; 
} 
$x_1nf = substr($x_1nb, -1); 
switch ($x_1nf) { 
case '.': 
case ',': 
case ':': 
case '?': 
case '!': 
case ')': 
$x_1nb = substr($x_1nb, 0, -1); 
$x_1b4 = $x_1nf . $x_1b4; 
break; 
case ']': 
if (substr($x_1n7[$x_a - 1], -1) == '[') { 
$x_1nb = substr($x_1nb, 0, -1); 
$x_1b4 = $x_1nf . $x_1b4; 
} 
break; 
default: 
break; 
} 
$x_1nb = str_replace('@', '&#64;', $x_1nb); 
$x_1ll .= '<a href="' . $x_1n9 . str_replace('"', '%22', $x_1nb) . '" target="_blank"' . $x_1n6 . '>' . 
$x_1n9 . $x_1nb . '</a>' . $x_1b4; 
} 
} 
if (strpos($x_1ll, '@') !== false) { 
$x_1ng = '/([a-z0-9_!=\+-]+(\.[a-z0-9_!=\+-]+)*@[a-z0-9_-]+(\.[a-z0-9_-]+)*)/i'; 
$x_1ll = preg_replace($x_1ng, $x_1mu, $x_1ll); 
} 
return $x_1ll; 
} 
function x_1lm(&$x_1bg) { 
$x_r = ''; 
if (preg_match('/<meta[^>]*charset\s*=[\s\'"]*([^\s\'">]*)/si', $x_1bg, $x_1mf)) { 
$x_r = strtolower($x_1mf[1]); 
if ($x_r == 'utf-16') { 
$x_r = ''; 
} 
} 
elseif (preg_match('/\0<\0m\0e\0t\0a[^>]*\0c\0h\0a\0r\0s\0e\0t[\0\s]*\0=[\0\s\'"]*([^\s\'">]*)/si', $x_1bg, $x_1mf)) { 
$x_r = strtolower(preg_replace('/\0/', '', $x_1mf[1])); 
} 
return $x_r; 
} 
function x_1m5($x_1nh) { 
$x_r = ""; 
$x_1mg = mb_strlen($x_1nh); 
for ($x_1l = 0; $x_1l < $x_1mg; $x_1l++) { 
$x_1ni = mb_substr($x_1nh, $x_1l, 1); 
$x_r .= (strlen($x_1ni) > 1 ? $x_1ni : rawurlencode($x_1ni)); 
} 
return $x_r; 
} 
function x_1nj(&$x_1jh, $x_1nk) { 
$x_1nl = array('text' => array(), 'css' => array()); 
foreach ($x_1nk as $x_1kj) { 
$x_1nl[$x_1kj] = array(); 
} 
$x_1nm = true; 
$x_1nn = false; 
foreach ($x_1jh as $x_a => $x_1z) { 
switch ($x_1z['type']) { 
case KMS_HTML_TAG: 
if (in_array($x_1z['value'], $x_1nk)) $x_1nl[$x_1z['value']][] = $x_a; 
if ($x_1z['value'] == "a") { 
$x_1nm = false; 
} 
elseif ($x_1z['value'] == "style") { 
$x_1nn = true; 
} 
break; 
case KMS_HTML_ENDTAG: 
if (in_array($x_1z['value'], $x_1nk)) $x_1nl[$x_1z['value']][] = -1 * $x_a; 
if ($x_1z['value'] == "a") { 
$x_1nm = true; 
} 
elseif ($x_1z['value'] == "style") { 
$x_1nn = false; 
} 
break; 
case KMS_HTML_TEXT: 
if ($x_1nn) { 
$x_1nl['css'][] = $x_a; 
} 
elseif ($x_1nm) { 
$x_1nl['text'][] = $x_a; 
} 
break; 
case KMS_HTML_COMMENT: 
if ($x_1nn) { 
$x_1nl['css'][] = $x_a; 
} 
break; 
} 
} 
return $x_1nl; 
} 
function x_1no(&$x_1jh, $x_1np, $x_1ms) { 
$x_1nq = array(); 
$x_1nr = false; 
$x_1ns = false; 
foreach ($x_1jh as $x_a => $x_1z) { 
switch ($x_1z['type']) { 
case KMS_HTML_TAG: 
$x_1ns = ($x_1z['value'] == 'style' || $x_1z['value'] == 'title'); 
$x_1nr = in_array($x_1z['value'], $x_1np); 
if (!$x_1nr && array_key_exists('attrib', $x_1z)) { 
$x_1z['attrib'] = x_1nt($x_1z['attrib'], $x_1ms); 
} 
break; 
case KMS_HTML_ENDTAG: 
if ($x_1ns && ($x_1z['value'] == 'style' || $x_1z['value'] == 'title')) { 
$x_1ns = false; 
} 
$x_1nr = in_array($x_1z['value'], $x_1np); 
if (array_key_exists('attrib', $x_1z)) unset($x_1z['attrib']); 
break; 
case KMS_HTML_TEXT: 
$x_1nr = $x_1ns; 
break; 
case KMS_HTML_COMMENT: 
$x_1nr = true; 
break; 
} 
if (!$x_1nr) $x_1nq[$x_a] = $x_1z; 
} 
return $x_1nq; 
} 
function x_1nt(&$x_1nu, $x_1ms) { 
$x_1mz = x_1mk(CSS_FILTER_RULES); 
$x_1mw = array_keys($x_1mz); 
$x_1nv = x_1mk(SRC_FILTER_RULES); 
$x_1nw = array_keys($x_1nv); 
$x_1nx = x_1mk(ATTRIB_FILTER_RULES); 
$x_1ny = array_keys($x_1nx); 
$x_1nz = array(); 
foreach ($x_1nu as $x_1kf => $x_1kg) { 
if ($x_1kg == "") { 
$x_1nz[$x_1kf] = ''; 
continue; 
} 
$x_1kg = str_replace("\\", "/", $x_1kg); 
switch ($x_1kf) { 
case 'href': 
case 'src': 
$x_1kg = preg_replace($x_1nw, $x_1nv, $x_1kg); 
$x_1o0 = false; 
break; 
case 'style': 
$x_1kg = x_1mv($x_1kg, $x_1mw, $x_1mz); 
$x_1kg = x_1mq($x_1kg, $x_1ms); 
$x_1o0 = false; 
break; 
case 'background': 
if (strtolower(substr($x_1kg, 0, 4)) == 'cid:') { 
$x_1kg = x_1mn($x_1kg); 
$x_1o0 = false; 
} 
elseif (!$x_1ms) { 
$x_1o0 = true; 
} 
else { 
$x_1kg = preg_replace($x_1nw, $x_1nv, $x_1kg); 
$x_1o0 = false; 
} 
break; 
default: 
$x_1kg = preg_replace($x_1ny, $x_1nx, $x_1kg); 
$x_1o0 = false; 
break; 
} 
if (!$x_1o0) { 
$x_1nz[$x_1kf] = $x_1kg; 
} 
} 
return $x_1nz; 
} 
function x_1o1(&$x_1jh) { 
$x_1o2 = 0; 
$x_1o3 = false; 
foreach ($x_1jh as $x_a => $x_1z) { 
switch ($x_1z['type']) { 
case KMS_HTML_TEXT: 
break; 
case KMS_HTML_TAG: 
switch ($x_1z['value']) { 
case 'table': 
if ($x_1o3) { 
unset($x_1jh[$x_a]); 
} 
else { 
$x_1o2++; 
$x_1o3 = true; 
} 
break; 
case 'td': 
case 'th': 
if ($x_1o2 > 0) { 
$x_1o3 = false; 
} 
else { 
unset($x_1jh[$x_a]); 
} 
break; 
case 'tr': 
case 'tbody': 
case 'thead': 
case 'tfoot': 
case 'caption': 
case 'col': 
case 'colgroup': 
if ($x_1o2 == 0) { 
unset($x_1jh[$x_a]); 
} 
break; 
} 
break; 
case KMS_HTML_ENDTAG: 
switch ($x_1z['value']) { 
case 'table': 
if ($x_1o2 > 0) { 
$x_1o2--; 
$x_1o3 = false; 
} 
else { 
unset($x_1jh[$x_a]); 
} 
break; 
case 'td': 
case 'th': 
case 'tr': 
case 'tbody': 
case 'thead': 
case 'tfoot': 
case 'caption': 
if ($x_1o2 == 0) { 
unset($x_1jh[$x_a]); 
} 
else { 
$x_1o3 = true; 
} 
break; 
} 
break; 
} 
} 
$x_1o4 = array( 
'type' => KMS_HTML_ENDTAG, 
'value' => 'table' 
); 
for ($x_1l = 1; $x_1l <= $x_1o2; $x_1l++) { 
$x_1jh[] = $x_1o4; 
} 
} 
function x_1o5(&$x_1jh, $x_1nl) { 
foreach ($x_1nl['css'] as $x_a) { 
$x_1o6 .= $x_1jh[$x_a]['value']; 
} 
foreach ($x_1nl['body'] as $x_a) { 
if ($x_a > 0) { 
if (array_key_exists('attrib', $x_1jh[$x_a])) $x_1o6 .= x_1o7($x_1jh[$x_a]['attrib']); 
break; 
} 
} 
return preg_replace(array("/\/\*.*\*\//Usi", "/<.*>/si", "/\s+/s", "/\s*([{},;:])\s*/"), array("", "", " ", "\\1"), $x_1o6); 
} 
function x_1o7($x_1nu) { 
$x_r = "\n*{"; 
foreach ($x_1nu as $x_1kf => $x_1kg) { 
if ($x_1kg == "") continue; 
switch ($x_1kf) { 
case "bgcolor": 
$x_1o8 = strtolower($x_1kg); 
if ($x_1o8 == '#ffffff' || $x_1o8 == 'white') { 
break; 
} 
$x_r .= "background-color" . ":" . $x_1kg . ";"; 
break; 
case "text": $x_r .= "color" . ":" . $x_1kg . ";"; break; 
case "leftmargin": $x_r .= "margin-left" . ":" . $x_1kg . "px;"; break; 
case "topmargin": $x_r .= "margin-right" . ":" . $x_1kg . "px;"; break; 
case "style": $x_r .= $x_1kg . (substr($x_1kg, -1) == ";" ? "" : ";"); break; 
} 
} 
return $x_r . "}"; 
} 
function x_1o9(&$x_1jh, $x_1nl) { 
if (count($x_1nl['base']) == 0) return ""; 
$x_1mg = count($x_1nl['head']); 
$x_1l = 0; 
while ($x_1l < $x_1mg && $x_1nl['head'][$x_1l] < 0) $x_1l++; 
$x_1oa = $x_1nl['head'][$x_1l]; 
while ($x_1l < $x_1mg && $x_1nl['head'][$x_1l] > 0) $x_1l++; 
$x_1ob = abs($x_1nl['head'][$x_1l]); 
foreach ($x_1nl['base'] as $x_a) { 
if ($x_a > $x_1oa && $x_a < $x_1ob && array_key_exists('attrib', $x_1jh[$x_a])) { 
$x_1oc = $x_1jh[$x_a]['attrib']['href']; 
if ($x_1oc != "") return $x_1oc; 
} 
} 
return ""; 
} 
function x_1od(&$x_1jh, $x_1nl) { 
$x_1mg = count($x_1nl['title']); 
for ($x_1l = 0; $x_1l < $x_1mg; $x_1l++) { 
if ($x_1nl['title'][$x_1l] > 0) { 
$x_a = $x_1nl['title'][$x_1l] + 1; 
break; 
} 
} 
if (!isset($x_a)) { 
return ''; 
} 
return ($x_1jh[$x_a]['type'] == KMS_HTML_TEXT ? $x_1jh[$x_a]['value'] : ''); 
} 
function x_1oe(&$x_1jh, $x_1nl, $x_1of) { 
if (substr($x_1of, -1) != "/") $x_1of .= "/"; 
foreach ($x_1nl['img'] as $x_a) { 
$x_1oc = $x_1jh[$x_a]['attrib']['src']; 
if ($x_1oc != "" && !preg_match("/^(cid:|https*:)/si", $x_1oc)) { 
$x_1oc = (substr($x_1oc, 0, 1) != "/" ? $x_1oc : substr($x_1oc, 1)); 
$x_1jh[$x_a]['attrib']['src'] = $x_1of . $x_1oc; 
} 
} 
foreach ($x_1nl['a'] as $x_a) { 
if ($x_a < 0) continue; 
$x_1oc = $x_1jh[$x_a]['attrib']['href']; 
if ($x_1oc != "" && !preg_match("/^(https*:|ftp:|mailto:|file:|#)/si", $x_1oc)) { 
$x_1oc = (substr($x_1oc, 0, 1) != "/" ? $x_1oc : substr($x_1oc,1)); 
$x_1jh[$x_a]['attrib']['href'] = $x_1of . $x_1oc; 
} 
} 
} 
function x_1og(&$x_1jh, $x_1nl, $x_1l1) { 
foreach ($x_1nl['a'] as $x_a) { 
if ($x_a < 0) continue; 
if (!isset($x_1jh[$x_a]['attrib']['href'])) { 
continue; 
} 
if (substr($x_1jh[$x_a]['attrib']['href'], 0, 1) !== "#") { 
$x_1jh[$x_a]['attrib']['target'] = "_blank"; 
if (!preg_match("/^[a-z]+:/i", $x_1jh[$x_a]['attrib']['href'])) { 
$x_1jh[$x_a]['attrib']['href'] = "http://" . $x_1jh[$x_a]['attrib']['href']; 
} 
} 
else { 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
$x_1jh[$x_a]['attrib']['class'] = "noHref"; 
$x_1jh[$x_a]['attrib']['onclick'] = "x_1oh('messageArea', '" . substr($x_1jh[$x_a]['attrib']['href'], 1) . "');"; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
default: 
break; 
} 
} 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
$x_1jh[$x_a]['attrib']['defaultcontextmenu'] = "yes"; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
default: 
break; 
} 
} 
} 
function x_1oi(&$x_1jh, $x_1nl, $x_1l1, $x_1ms) { 
global $x_1m2; 
switch ($x_1l1) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$x_1mp = "../webmail/"; 
break; 
case MODE_ATTACHMENT: 
$x_1mp = '../'; 
break; 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
default: 
$x_1mp = ""; 
break; 
} 
$x_1mp .= "mailAttach.php?folder=" . urlencode($x_1m2['folder']) . "&uid=" . $x_1m2['uid'] . "&cid="; 
foreach ($x_1nl['img'] as $x_a) { 
if (substr($x_1jh[$x_a]['attrib']['src'], 0, 4) == "cid:") { 
$x_1m2['cidsShownInline'][] = strtolower("<" . substr($x_1jh[$x_a]['attrib']['src'], 4) . ">"); 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
case MODE_ATTACHMENT: 
$x_1jh[$x_a]['attrib']['src'] = $x_1mp . substr($x_1jh[$x_a]['attrib']['src'], 4); 
break; 
case MODE_COMPOSE_FULL: 
default: 
break; 
} 
} 
elseif (!$x_1ms) { 
unset($x_1jh[$x_a]); 
} 
} 
} 
function x_1oj(&$x_1jh, $x_1nl, $x_1l1) { 
foreach ($x_1nl['text'] as $x_a) { 
if (isset($x_1jh[$x_a])) { 
$x_1jh[$x_a]['value'] = x_1n4($x_1jh[$x_a]['value'], $x_1l1); 
} 
} 
} 
function x_1ok($x_1x, $x_1kz) { 
$x_r = ""; 
while (mb_strlen($x_1x) > $x_1kz) { 
$x_1n1 = $x_1kz; 
$x_1ol = mb_substr($x_1x, 0, $x_1n1); 
$x_1om = mb_strrpos($x_1ol, " "); 
if ($x_1om > 0) { 
$x_1ol = mb_substr($x_1x, 0, $x_1om); 
$x_1n1 = $x_1om + 1; 
} 
else { 
$x_1om = mb_strrpos($x_1ol, "&"); 
if ($x_1om > 0) { 
$x_1ol = mb_substr($x_1x, 0, $x_1om); 
$x_1n1 = $x_1om; 
} 
} 
$x_r .= $x_1ol . " "; 
$x_1x = mb_substr($x_1x, $x_1n1); 
} 
return $x_r . $x_1x; 
} 
function x_1on($x_1ll, $x_1l1) { 
if (strlen($x_1ll) >= MAX_CONTENT_LENGTH) { 
return nl2br(x_1b8($x_1ll)); 
} 
$x_1oo = x_1n0($x_1ll); 
$x_1op = explode("\n", $x_1ll); 
$x_1ll = ''; 
foreach ($x_1op as $x_4) { 
if (strpos($x_4, "\t") !== false) { 
$x_1oq = explode("\t", $x_4); 
$x_1or = count($x_1oq) - 1; 
$x_4 = ''; 
for ($x_1l = 0; $x_1l < $x_1or; $x_1l++) { 
$x_1os = $x_1oq[$x_1l]; 
$x_4 .= $x_1os . substr(TAB_SPACE, 0, TAB_SIZE - (mb_strlen($x_1os) % TAB_SIZE)); 
} 
$x_4 .= $x_1oq[$x_1or]; 
} 
$x_4 = x_1b8($x_4); 
if ($x_1oo) { 
$x_4 = x_1n4($x_4, $x_1l1); 
} 
if (substr($x_4, 0, 1) == ' ') { 
$x_4 = '&nbsp;' . substr($x_4, 1); 
} 
$x_4 = str_replace('  ', ' &nbsp;', $x_4); 
$x_1ll .= '<br>' . $x_4; 
} 
return substr($x_1ll, strlen('<br>')); 
} 
function x_1ot($x_1ll, $x_1ou, $x_1l1, $x_1lh = '0', $x_1ms = false) { 
switch (strtolower($x_1ou)) { 
case "text/html": 
if ($x_1l1 != MODE_COMPOSE_FULL) { 
$x_1io = x_1lm($x_1ll); 
if ($x_1io == 'utf-16') { 
$x_1ll = kerio_convert($x_1io, 'utf-8', $x_1ll); 
$x_1io = 'utf-8'; 
} 
} 
$x_1jl = Array( 
'blackPairList' => Array('iframe','script','textarea'), 
'whiteTagList' => Array('a','address','b','base','big','blockquote','body','br','caption','center','cite','code','col','colgroup','dd','dir','div','dl','dt','em','font','fieldset','h1','h2','h3','h4','h5','h6','head','hr','html','i','img','legend','li','meta','ol','option','p','pre','q','s','samp','select','small','span','strike','strong','style','sub','sup','table','tbody','td','tfoot','th','thead','title','tr','tt','u','ul','xmp'), 
'whiteAttribList' => Array('align','alt','background','bgcolor','border','cellspacing','cellpadding','class','clear','color','colspan','content','face','height','hspace','href','http-equiv','id','leftmargin','name','nowrap','rowspan','size','src','style','text','title','topmargin','type','valign','vspace','width') 
); 
$x_1np = Array('base','body','head','html','meta','style','title'); 
if (!USE_PHP_PARSER) { 
$x_1ov = kerio("KMS::HTMLParser"); 
$x_1ov->setPairBlacklist($x_1jl['blackPairList']); 
$x_1ov->setTagWhitelist($x_1jl['whiteTagList']); 
$x_1ov->setAttribWhitelist($x_1jl['whiteAttribList']); 
$x_1jh = $x_1ov->parse('<!---->' . $x_1ll); 
} 
else { 
$x_1ov = new x_1jd($x_1ll, $x_1jl); 
$x_1jh = $x_1ov->x_1ju(); 
} 
$x_1nl = x_1nj($x_1jh, ($x_1l1 != MODE_ATTACHMENT ? 
array('head','base','body','a','img') : 
array('head','base','body','a','img', 'title') 
)); 
$x_1o6 = x_1o5($x_1jh, $x_1nl); 
$x_1ow = x_1o9($x_1jh, $x_1nl); 
if ($x_1l1 == MODE_ATTACHMENT) { 
$x_1ox = ($x_1io != '' ? 
'<meta http-equiv="Content-Type" content="text/html; charset=' . x_1b8($x_1io) . '">' : 
'' 
); 
$x_1b3 = x_1od($x_1jh, $x_1nl); 
if ($x_1b3 != '') { 
$x_1ox .= '<title>' . x_1b8($x_1b3) . '</title>'; 
} 
} 
$x_1jh = x_1no($x_1jh, $x_1np, $x_1ms); 
if ($x_1ow != "") { 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
case MODE_COMPOSE_FULL: 
x_1oe($x_1jh, $x_1nl, $x_1ow); 
break; 
case MODE_ATTACHMENT: 
$x_1ox .= '<base href="' . x_1b8($x_1ow) . '">'; 
break; 
default: 
break; 
} 
} 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
x_1og($x_1jh, $x_1nl, $x_1l1); 
break; 
case MODE_COMPOSE_FULL: 
case MODE_ATTACHMENT: 
default: 
break; 
} 
x_1oi($x_1jh, $x_1nl, $x_1l1, $x_1ms); 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
case MODE_COMPOSE_FULL: 
if (x_1n0($x_1ll)) x_1oj($x_1jh, $x_1nl, $x_1l1); 
break; 
case MODE_ATTACHMENT: 
default: 
break; 
} 
switch ($x_1l1) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
x_1o1($x_1jh); 
break; 
} 
if (!USE_PHP_PARSER) { 
$x_1ll = $x_1ov->getHtml($x_1jh); 
} 
else { 
$x_1ll = 'PHP parser::' . $x_1ov->x_1kd($x_1jh); 
} 
unset($x_1jh); 
$x_1mi = x_1my(x_1me($x_1o6), $x_1l1, $x_1ms); 
switch ($x_1l1) { 
case MODE_DISPLAY_FULL: 
$x_1oy = MAIN_CONTENT_SELECTOR . str_replace('.', '_', $x_1lh); 
$x_1mi = x_1mh($x_1mi, '#' . $x_1oy); 
$x_1ll = 
"\n<div id='" . $x_1oy . "'>" . $x_1ll . '</div>' . 
"<style>" . x_1mj($x_1mi) . "\n</style>\n"; 
break; 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$x_1mi = x_1mh($x_1mi, "#" . MAIN_CONTENT_SELECTOR . $x_1lh); 
print "\n<style>" . x_1mj($x_1mi) . "\n</style>\n"; 
break; 
case MODE_ATTACHMENT: 
$x_1ox .= '<style>' . x_1mj($x_1mi) . '</style>'; 
$x_1ll = '<html><head>' . $x_1ox . '</head><body>' . $x_1ll . '</body></html>'; 
break; 
case MODE_COMPOSE_FULL: 
default: 
$x_1ll .= "</blockquote><style>" . x_1mj($x_1mi) . "\n</style>\n"; 
break; 
} 
break; 
case "text/plain": 
$x_1ll = x_1on($x_1ll, $x_1l1); 
switch ($x_1l1) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$x_1ll = "<tt>" . $x_1ll . "</tt>"; 
break; 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
default: 
$x_1ll = "<span style='font:90% monospace;margin-top:0px;'>" . $x_1ll . "</span>"; 
break; 
} 
break; 
case "text/enriched": 
$x_1ll = preg_replace("/([^\n])\r\n([^\r])/s", "\\1 \\2", $x_1ll); 
$x_1ll = preg_replace("/\r\n(\r\n){1,}/sU", "\\1", $x_1ll); 
$x_1ll = preg_replace("|<param.*</param>|Usi", "", $x_1ll); 
$x_1ll = strip_tags($x_1ll); 
switch ($x_1l1) { 
case MODE_DISPLAY_MINI: 
case MODE_DISPLAY_PDA: 
$x_1ll = nl2br($x_1ll); 
break; 
case MODE_DISPLAY_FULL: 
case MODE_COMPOSE_FULL: 
default: 
break; 
} 
break; 
default: 
$x_1ll = 'Error: invalid Content-Type ' . $x_1ou . '!'; 
break; 
} 
if ($x_1l1 == MODE_DISPLAY_PDA) { 
$x_1ll = preg_replace("/&nbsp;/", " ", $x_1ll); 
$x_1ll = '<!-- -->' . preg_replace("/(<\/*)PRE[^>]*>/si", "\\1p>", $x_1ll); 
preg_match_all("/(<[^>]*>)([^<]*)/si", $x_1ll, $x_r, PREG_SET_ORDER); 
$x_1ll = ""; 
foreach ($x_r as $x_1oz) { 
$x_1ll .= $x_1oz[1] . x_1ok($x_1oz[2], PDA_DETAIL_LENGTH, " ", 1); 
} 
} 
return $x_1ll; 
} 
?>