<?php
require_once(dirname(__FILE__) . '/../lib/webmail/folder.inc'); 
function x_232($x_1qd) { 
switch ($x_1qd) { 
case FLD_INBOX: return kerio_translate(x_1dr::x_1dx('lang'), "fld-inbox"); 
case FLD_SENT: return kerio_translate(x_1dr::x_1dx('lang'), "fld-sent"); 
case FLD_DRAFT: return kerio_translate(x_1dr::x_1dx('lang'), "fld-drafts"); 
case FLD_JUNK: return kerio_translate(x_1dr::x_1dx('lang'), "fld-junk"); 
case FLD_TRASH: return kerio_translate(x_1dr::x_1dx('lang'), "fld-trash"); 
case FLD_CONTACT: return kerio_translate(x_1dr::x_1dx('lang'), "fld-contacts"); 
case FLD_CALENDAR: return kerio_translate(x_1dr::x_1dx('lang'), "fld-calendar"); 
case FLD_TODO: return kerio_translate(x_1dr::x_1dx('lang'), "fld-tasks"); 
case FLD_PUBLIC: return kerio_translate(x_1dr::x_1dx('lang'), "fld-public"); 
case FLD_ARCHIVE: return kerio_translate(x_1dr::x_1dx('lang'), "fld-archive"); 
} 
return kerio_convert("utf-7m", "utf-8", $x_1qd); 
} 
function x_1s2($x_233, $x_1qr, $x_1sv) { 
if ($x_1qr == "") return false; 
if (ereg('\\|\/|\*|\?|\"|\<|\>|\||\:', $x_1qr)) { 
x_1sp(1401, "invalid character"); return false; 
} 
elseif (strlen($x_1qr) > 512) { 
x_1sp(1401, "too long folder name"); return false; 
} 
$x_1so = kerio('KMS::FolderStore'); 
if ($x_1so->createFolder($x_233 . "/" . $x_1qr, $x_1sv) != 0) { 
x_1sp(1401, array($x_233, $x_1qr)); return false; 
} 
return true; 
} 
function x_1s5($x_1s6, $x_1s4, $x_1d7 = "") { 
if ($x_1s4 == "" || $x_1s6 == $x_1s4 || x_1ic($x_1s6, WME_MY_FOLDER)) return false; 
if (ereg('\\|\/|\*|\?|\"|\<|\>|\||\:', $x_1d7)) { 
x_1sp(1411, "invalid character"); return false; 
} 
elseif (strlen($x_1d7) > 512) { 
x_1sp(1411, "too long folder name"); return false; 
} 
$x_1so = kerio('KMS::FolderStore'); 
if ($x_1so->renameFolder($x_1s6, $x_1s4) != 0) { 
x_1sp(1411, array($x_1s6, $x_1s4)); return false; 
} 
return true; 
} 
function x_1s8($x_1qd) { 
if (x_1ic($x_1qd, WME_MY_FOLDER)) return false; 
$x_1so = kerio('KMS::FolderStore'); 
if ($x_1so->deleteFolder($x_1qd, true) != 0) { 
x_1sp(1421, $x_1qd); return false; 
} 
return true; 
} 
function x_1s7($x_234, $x_235) { 
$x_1so = kerio('KMS::FolderStore'); 
$x_1qd = $x_235 . strrchr($x_234, "/"); 
$x_1s4 = $x_1qd; 
$x_236 = 1; 
while ($x_1so->folderExists($x_1s4)) { 
$x_1s4 = $x_1qd . $x_236++; 
} 
return $x_1s4; 
} 
function x_1qs() { 
$x_h = kerio('KMS::UserInfo'); 
$x_1qd = "~" . $x_h->getUserName() . "/" . FLD_TRASH . "/" . FLD_CONTACT; 
$x_1so = kerio('KMS::FolderStore'); 
$x_237 = $x_1so->openFolder($x_1qd, FLD_CONTACT); 
if (is_null($x_237)) { 
if ($x_1so->createFolder($x_1qd, KMS_FCONTACT) != 0) return ""; 
} 
unset($x_237); 
return $x_1qd; 
} 
function x_1s9($x_b, $x_1lf) { 
switch ($x_1lf) { 
case 'U': 
$x_238 = explode('@', $x_b); 
$x_1mg = count($x_238); 
switch ($x_1mg) { 
case 1: 
$x_1uu = kerio_is_valid_username($x_b); 
break; 
case 2: 
$x_1uu = (kerio_is_valid_username($x_238[0]) && kerio_is_valid_domainname($x_238[1])); 
break; 
default: 
$x_1uu = false; 
break; 
} 
if (!$x_1uu) { 
x_1dr::x_1dy('<kerio:text id="alert-invalid-username-or-email"/>', 'warningTxt'); 
return false; 
} 
break; 
case 'G': 
if (preg_match('/[,\[\]]/', $x_b)) { 
x_1dr::x_1dy('<kerio:text id="alert-invalid-group"/>', 'warningTxt'); 
return false; 
} 
break; 
case 'D': 
if (!kerio_is_valid_domainname($x_b)) { 
x_1dr::x_1dy('<kerio:text id="alert-invalid-domain"/>', 'warningTxt'); 
return false; 
} 
break; 
} 
return true; 
} 
function x_1sb($x_1qd, $x_19n, $x_1tp) { 
if ($x_1qd == "" || $x_19n == "") { 
return; 
} 
$x_1so = kerio('KMS::FolderStore'); 
if ($x_1tp == WME_REMOVE_ALL_RIGHTS) { 
foreach ($x_19n as $x_18a) { 
$x_1ly = $x_1so->deleteFolderAcl($x_1qd, $x_18a); 
} 
} 
else { 
if ((strpos($x_19n, "@") === false && $x_19n != "anyone" && $x_19n != "authuser") || ($x_19n == "authuser@")) { 
$x_h = kerio('KMS::UserInfo'); 
$x_239 = $x_h->getUserName(); 
$x_19n = ($x_19n == "authuser@" ? "authuser" : $x_19n) . strstr($x_239, "@"); 
} 
if ($x_19n == $x_239) return; 
if (!$x_1so->setFolderAcl($x_1qd, $x_19n, ($x_1tp == "R" ? "lr" : ($x_1tp == "E" ? "lrswid" : "lrswicda")))) { 
x_1sp(1451, array($x_1qd, $x_19n, $x_1tp)); 
} 
} 
} 
function x_1sc($x_19n) { 
if ($x_19n == "") return false; 
$x_23a = false; 
$x_23b = 0; 
if (strpos($x_19n, "@") === false) { 
$x_h = kerio('KMS::UserInfo'); 
$x_19n .= strstr($x_h->getUserName(), "@"); 
} 
if (substr($x_19n, 0, 1) !== "~") $x_19n = "~" . $x_19n; 
$x_1so = kerio('KMS::FolderStore'); 
$x_23c = $x_1so->listFolders($x_19n . "/*", KMS_FANY, 0); 
$x_23d = $x_1so->getSharedFolderMappings(); 
foreach ($x_23c as $x_237) { 
if ($x_237['type'] != KMS_FMAIL && $x_237['type'] != KMS_FCONTACT) continue; 
$x_23b++; 
if ((in_array($x_237['name'], $x_23d)) === false) { 
if (!$x_1so->mapSharedFolder($x_237['name'])) $x_23a = true; 
} 
} 
if ($x_23a) x_1sp(1461, $x_19n); 
return $x_23b; 
} 
function x_1se($x_1qd, $x_23e) { 
$x_1so = kerio('KMS::FolderStore'); 
if ($x_23e) { 
$x_23c = $x_1so->listFolders($x_1qd . "/*", KMS_FANY, 0); 
if (count($x_23c)) foreach ($x_23c as $x_237) { 
$x_1so->unmapSharedFolder($x_237['name']); 
} 
} 
else { 
$x_1so->unmapSharedFolder($x_1qd); 
} 
} 
function x_1sd($x_19n) { 
$x_h = kerio('KMS::UserInfo'); 
$x_23f = $x_h->getUserName(); 
if (strpos($x_19n, "@") === false) $x_19n.= strstr($x_23f, "@"); 
$x_1so = kerio('KMS::FolderStore'); 
$x_23c = $x_1so->listFolders("~" . $x_23f . "/~" . $x_19n . "/*", KMS_FANY, 0); 
foreach ($x_23c as $x_237) { 
if ($x_237['isSelectable'] && ($x_237['type'] == KMS_FMAIL || $x_237['type'] == KMS_FCONTACT)) return $x_237['name']; 
} 
return ""; 
} 
function x_1pj() { 
$x_1so = kerio('KMS::FolderStore'); 
$x_h = kerio('KMS::UserInfo'); 
$x_23c = $x_1so->listFolders("~" . $x_h->getUserName() . "/*", KMS_FANY, 0); 
$x_23g = $x_1so->getSharedFolderMappings(); 
$x_1mm = ""; 
foreach ($x_23c as $x_237) { 
$x_1mm[] = array( 
'name' => $x_237['name'], 
'nameLocal' => "", 
'subList' => substr_count($x_237['name'], "/") - 1, 
'rights' => ($x_237['isShared'] ? "S" : (strpos($x_237['myRights'], "a") !== false ? "A" : (strpos($x_237['myRights'], "d") !== false ? "E" : "R"))), 
'type' => ($x_237['isSelectable'] ? $x_237['type'] : WME_NOT_SELECTABLE), 
'unseen' => ($x_237['isSelectable'] ? ($x_237['messageUnseenCount'] ? "(" . $x_237['messageUnseenCount'] . ")" : "") : ""), 
'total' => $x_237['messageCount']); 
} 
$x_1mg = count($x_1mm); $x_23h = $x_1mm[$x_1mg - 1]['name']; 
for ($x_1l = $x_1mg - 1; $x_1l >= 0; $x_1l--) { 
$x_1mm[$x_1l]['display'] = (strpos($x_23h . "/", $x_1mm[$x_1l]['name'] . "/") !== false ? WME_CLOSED_SUBFOLDERS : WME_NO_SUBFOLDERS); 
if ($x_1mm[$x_1l]['type'] == KMS_FMAIL || $x_1mm[$x_1l]['type'] == KMS_FCONTACT) { 
$x_23h = $x_1mm[$x_1l]['name']; 
} 
elseif (in_array(substr(strstr($x_1mm[$x_1l]['name'], "/"), 1), $x_23g) && ($x_23c[$x_1l]['type'] == KMS_FMAIL || $x_23c[$x_1l]['type'] == KMS_FCONTACT)) { 
$x_1mm[$x_1l]['type'] = WME_NOT_ACCESSIBLE; 
} 
elseif (strpos($x_23h . "/", $x_1mm[$x_1l]['name'] . "/") === false) { 
$x_1mm[$x_1l]['nameLocal'] = "-1"; 
} 
else { 
$x_1mm[$x_1l]['type'] = WME_NOT_SELECTABLE; 
} 
} 
$x_1l = $x_1mg - 1; 
while ($x_1l > 1 && $x_23c[$x_1l]['type'] != KMS_FMAIL && $x_23c[$x_1l]['type'] != KMS_FCONTACT) { 
$x_1mm[$x_1l]['nameLocal'] = -1; 
$x_1l--; 
} 
$x_1mm[$x_1l]['display'] = WME_NO_SUBFOLDERS; 
$x_1pi = ""; $x_23i = 0; 
foreach ($x_1mm as $x_1rn) { 
if ($x_1rn['nameLocal'] == "") { 
$x_23j = explode("/", $x_1rn['name']); 
$x_23j[0] = ""; 
$x_1mg = count($x_23j); 
if ($x_23j[1] == FLD_PUBLIC && $x_23j[2] != "" || $x_23j[1] == FLD_TRASH && $x_23j[2] == FLD_CONTACT) { 
$x_23j[1] = x_232($x_23j[1]); 
$x_23j[2] = ($x_23j[2] != FLD_RESOURCES) ? 
x_232($x_23j[2]) : 
kerio_translate(x_1dr::x_1dx('lang'), 'fld-resources'); 
$x_1hu = 3; 
} 
else { 
$x_1hu = min($x_1mg - 1, (substr($x_23j[1], 0, 1) != "~" ? 1 : 2)); 
$x_23j[$x_1hu] = x_232($x_23j[$x_1hu]); 
$x_1hu++; 
} 
for ($x_1l = $x_1hu; $x_1l < $x_1mg; $x_1l++) $x_23j[$x_1l] = kerio_convert("utf-7m", "utf-8", $x_23j[$x_1l]); 
$x_1rn['nameLast'] = x_1b8($x_23j[$x_1mg - 1]); 
$x_1rn['shortLast'] = x_1b8(x_1x7($x_23j[$x_1mg - 1], FLD_OUTPUT_LENGTH)); 
if (x_1dr::x_1dx('pda') == 0) { 
$x_1p3 = substr(implode(" : ", $x_23j), 3); 
if ($x_1rn['subList'] > 0) { 
$x_1n1 = mb_strlen($x_1p3); 
if ($x_1n1 > 2 * 20 + 3) { 
$x_1n1 = ceil(2 * 20 / ($x_1mg - 1)); 
for ($x_1l = 1; $x_1l < $x_1mg; $x_1l++) if (mb_strlen($x_23j[$x_1l]) > $x_1n1) $x_23j[$x_1l] = mb_substr($x_23j[$x_1l], 0, $x_1n1) . "..."; 
$x_1p3 = substr(implode(" : ", $x_23j), 3); 
} 
} 
$x_1rn['nameLocal'] = x_1b8($x_1p3, ENT_QUOTES); 
} 
else { 
$x_1n1 = (strpos($x_23j[$x_1mg - 1], "<kerio:text") !== false ? -1 : mb_strlen($x_23j[$x_1mg - 1])); 
if ($x_1n1 > 15) { 
$x_23j[$x_1mg - 1] = mb_substr($x_23j[$x_1mg - 1], 0, 12) . "..."; 
} 
$x_1if = ""; 
for ($x_1l = 2; $x_1l < $x_1mg; $x_1l++) $x_1if .= "- "; 
$x_1rn['nameLocal'] = $x_1if . x_1b8($x_23j[$x_1mg - 1]); 
} 
$x_1pi[($x_1rn['name'] == x_1dr::x_1dx('fld') ? WME_CURRENT_FOLDER : $x_23i++)] = $x_1rn; 
} 
} 
if (x_1dr::x_1dx('pda') == 0) { 
$x_23k = array(); 
foreach ($x_1pi as $x_1rn) { 
$x_z = $x_1rn['name']; 
$x_23l = $x_1rn['nameLocal']; 
$x_23k[$x_z] = $x_23l; 
$x_21k = explode("/", $x_z); 
$x_23m = explode(" : ", $x_23l); 
$x_1mg = count($x_21k); 
$x_23n = $x_21k[0]; 
$x_23o = $x_23m[0]; 
for ($x_1l = 1; $x_1l < $x_1mg; $x_1l++) { 
$x_23n .= "/" . $x_21k[$x_1l]; 
if (mb_strlen($x_23k[$x_23n]) > mb_strlen($x_23o)) $x_23k[$x_23n] = $x_23o; 
$x_23o .= " : " . $x_23m[$x_1l]; 
} 
} 
foreach ($x_1pi as $x_a => $x_1rn) { 
if ($x_1pi[$x_a]['subList'] > 0) { 
$x_1cf = mb_substr($x_1pi[$x_a]['name'], 0, strrpos($x_1pi[$x_a]['name'], "/")); 
$x_1pi[$x_a]['nameLocal'] = $x_23k[$x_1cf] . " : " . $x_1pi[$x_a]['shortLast']; 
} 
elseif ($x_1pi[$x_a]['subList'] == 0) { 
$x_1pi[$x_a]['nameLocal'] = $x_1pi[$x_a]['shortLast']; 
} 
} 
} 
foreach ($x_1pi as $x_a => $x_1rn) { 
foreach (array('nameLocal', 'nameLast', 'shortLast') as $x_23p) { 
$x_1pi[$x_a][$x_23p] = str_replace("  ", " &nbsp;", $x_1pi[$x_a][$x_23p]); 
} 
} 
return $x_1pi; 
} 
function x_1pl($x_1pi, $x_19m) { 
if (!is_array($x_1pi)) return ""; 
$x_1l = 0; 
$x_1mm = array(); 
foreach ($x_1pi as $x_1rn) { 
$x_a = ($x_1rn['name'] != $x_19m ? $x_1l++ : WME_CURRENT_FOLDER); 
$x_1mm[$x_a] = $x_1rn; 
} 
return $x_1mm; 
} 
function x_1pe($x_23q, $x_1qd, $x_1s4 = "") { 
$x_h = kerio('KMS::UserInfo'); 
$x_1ix = $x_h->getSettings(); 
$x_23r = explode("|", $x_1ix['toggledFld']); 
switch ($x_23q) { 
case WME_RENAME_FOLDER: 
$x_1p3 = array(); 
if (is_array($x_23r)) foreach ($x_23r as $x_23s) { 
$x_1p3[] = str_replace($x_1qd, $x_1s4, $x_23s); 
} 
$x_23r = $x_1p3; 
break; 
case WME_PACK_FOLDER: 
$x_1p3 = array(); 
if (is_array($x_23r)) foreach ($x_23r as $x_23s) { 
if ($x_23s != $x_1qd) $x_1p3[] = $x_23s; 
} 
$x_23r = $x_1p3; 
break; 
case WME_UNPACK_FOLDER: 
if (array_search($x_1qd, $x_23r) === false) $x_23r[] = $x_1qd; 
break; 
case WME_UNPACK_ALL_FOLDERS: 
$x_1p3 = explode("/", $x_1qd); 
$x_1mg = count($x_1p3); 
$x_1pm = $x_1p3[0]; 
for ($x_1l = 1; $x_1l < $x_1mg; $x_1l++) { 
$x_1pm .= "/" . $x_1p3[$x_1l]; 
if (array_search($x_1pm, $x_23r) === false) $x_23r[] = $x_1pm; 
} 
break; 
} 
$x_1ix['toggledFld'] = implode("|", $x_23r); 
if (!$x_h->saveSettings($x_1ix)) x_1sp(1431); 
} 
function x_1vo($x_1pi) { 
$x_h = kerio('KMS::UserInfo'); 
$x_1ix = $x_h->getSettings(); 
$x_19n = $x_h->getUserName(); 
switch ($x_1pi[WME_CURRENT_FOLDER]['type']) { 
case KMS_FMAIL: $x_1bc = "browse.php"; break; 
case KMS_FCONTACT: $x_1bc = "contact.php"; break; 
default: $x_1bc = ""; break; 
} 
?>
<table cellspacing='0' cellpadding='2' border='0' xwidth='100%' class='menuTable'>
<tr class='head'>
<td nowrap align='left'>
<kerio:text id='main-folders'/>
<span class='bracket'>[&nbsp;<a href='folder.php'><kerio:text id='express-admin-on'/></a>&nbsp;]</span>
</td>
</tr>
<tr class='tree'>
<td nowrap class='topMargin'>
<img src='/webmail/img/user.gif' width='16' height='16' alt='*' title=''>
<a href='quota.php'>
<?php
print 
(x_1dr::x_1dx('fld') !== "" ? "" : "<b class='actFolder'>") . 
(mb_strlen($x_19n) > USERNAME_LENGTH + 3 ? mb_substr($x_19n, 0, USERNAME_LENGTH) . "..." : $x_19n) . 
(x_1dr::x_1dx('fld') !== "" ? "" : "</b>") 
?>
</a>&nbsp;
</td>
</tr>
<tr class='tree'>
<td valign='top' nowrap>
<ul class='firstUl'>
<?php
$x_23t = 0; 
$x_r = ""; 
$x_23u = 0; 
$x_23r = explode("|", $x_1ix['toggledFld']); 
foreach ($x_1pi as $x_a => $x_1rn) { 
if ($x_1rn['subList'] == 0 || ($x_1rn['subList'] <= $x_23u && array_search(substr($x_1rn['name'], 0, strrpos($x_1rn['name'], "/")), $x_23r) !== false)) { 
$x_23u = $x_1rn['subList'] + 1; 
for ($x_23v = $x_23t; $x_23v < $x_1rn['subList']; $x_23v++) { 
$x_r .= "<ul>"; 
} 
for ($x_23v = $x_1rn['subList']; $x_23v < $x_23t; $x_23v++) { 
$x_r .= "</ul>"; 
} 
$x_23t = $x_1rn['subList']; 
if ($x_a === WME_CURRENT_FOLDER) { 
$x_1u4 = "<b class='actFolder'>"; $x_1u5 = "</b>"; 
} 
else { 
$x_1u4 = $x_1u5 = ""; 
} 
$x_r .= "<li>"; 
if ($x_1rn['display'] != WME_NO_SUBFOLDERS && array_search($x_1rn['name'], $x_23r) !== false) $x_1rn['display'] = WME_OPENED_SUBFOLDERS; 
switch ($x_1rn['display']) { 
case WME_CLOSED_SUBFOLDERS: 
$x_r .= "<a href='" . $x_1bc . "?actionn=folderMinus&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&pmFld=" . urlencode($x_1rn['name']) . "'><img src='/webmail/img/plus.gif' width='16' height='16' border='0' alt='+' title=''></a>"; 
$x_23w = $x_1rn['subList']; 
break; 
case WME_OPENED_SUBFOLDERS: 
$x_r .= "<a href='" . $x_1bc . "?actionn=folderPlus&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&pmFld=" . urlencode($x_1rn['name']) . "'><img src='/webmail/img/minus.gif' width='16' height='16' border='0' alt='-' title=''></a>"; 
break; 
case WME_NO_SUBFOLDERS: 
$x_r .= "<img src='img/trpix.gif' width='16' height='16'>"; 
$x_23w = $x_1rn['subList']; 
break; 
} 
switch ($x_1rn['type']) { 
case KMS_FMAIL: 
$x_23x = (strstr($x_1rn['name'], "/") == "/" . FLD_INBOX ? "fmail_yellow" : (strstr($x_1rn['name'], "/") == "/" . FLD_TRASH ? "ftrash" : "fmail")); 
$x_23y = false; 
$x_23z = true; 
$x_240 = "browse.php?actionn=browseSearchOff&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&"; 
break; 
case KMS_FCONTACT: 
$x_23x = "fcontact"; 
$x_23y = false; 
$x_23z = true; 
$x_240 = "contact.php?actionn=contactSearchOff&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&"; 
break; 
case WME_NOT_ACCESSIBLE: 
$x_23x = "folder_gray"; 
$x_23z = false; 
break; 
default: 
$x_23x = "folder"; 
$x_23y = true; 
$x_23z = ($x_1rn['type'] != WME_NOT_SELECTABLE && ($x_1rn['rights'] == "A" || $x_1rn['rights'] == "S")); 
$x_240 = "browse.php?"; 
break; 
} 
$x_19m = ($x_1rn['shortLast'] == $x_1rn['nameLast'] ? $x_1rn['nameLast'] : "<span title='" . $x_1rn['nameLast'] . "'>" . $x_1rn['shortLast'] . "</span>"); 
$x_r .= 
($x_23z ? "<a href='" . $x_240 . "fld=" . urlencode($x_1rn['name']) . ($x_23y ? "" : "&pag=0") . "'>" : "") . 
"<img src='/webmail/img/" . $x_23x . ($x_1rn['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' border='0'>&nbsp;" . 
$x_1u4 . $x_19m . "&nbsp;". $x_1rn['unseen'] . $x_1u5 . 
($x_23z ? "</a>" : "") . "</li>\n"; 
} 
} 
for ($x_1l = 0; $x_1l < $x_23w; $x_1l++) $x_r .= "</ul>"; 
print $x_r; 
?>
</ul>
</td>
</tr>
</table>
<?php
} 
function x_1vq($x_1pi) { 
switch ($x_1pi[WME_CURRENT_FOLDER]['type']) { 
case KMS_FMAIL: $x_1bc = "browse.php"; $x_241 = 'browseGo'; break; 
case KMS_FCONTACT: $x_1bc = "contact.php"; $x_241 = 'contactGo';break; 
default: return; 
} 
$x_h = kerio('KMS::UserInfo'); 
$x_19n = $x_h->getUserName(); 
$x_1yv = (x_1dr::x_1dx('pda') == 0 ? USERNAME_LENGTH : PDA_USERNAME_LENGTH); 
$x_r = 
"<table cellpadding='0' cellspacing='2' border='0'>" . 
"<tr><td nowrap>" . 
"<input type='hidden' name='adm' value='0'>" . 
"<select name='fld' id='fldCombox'>" . 
"<option value='root'>" . 
(mb_strlen($x_19n) > $x_1yv + 3 ? mb_substr($x_19n, 0, $x_1yv) . "..." : $x_19n) . 
"</option>"; 
foreach ($x_1pi as $x_a => $x_1rn) { 
if ($x_1rn['type'] != KMS_FMAIL && $x_1rn['type'] != KMS_FCONTACT) continue; 
$x_r .= 
"<option " . ($x_a === WME_CURRENT_FOLDER ? "selected " : "") . 
"value='" . ($x_1rn['type'] != $x_1pi[WME_CURRENT_FOLDER]['type'] ? "!" : "") . x_1b8($x_1rn['name']) . "'>" . $x_1rn['nameLocal'] . ($x_1rn['unseen'] != "" ? " " : "") . $x_1rn['unseen'] . 
"</option>"; 
} 
print $x_r . 
"</select>&nbsp;". 
"<input id='goButton' type='submit' name='" . $x_241 . "' value='<kerio:text id='express-go'/>'>" . 
(x_1dr::x_1dx('fld') !== "" && x_1dr::x_1dx('pda') == 0 ? 
"<td><span class='bracket'>&nbsp;[&nbsp;<a href='folder.php'><kerio:text id='express-admin-on'/></a>&nbsp;]</span></td>" : "") . 
"</td></tr></table>"; 
} 
function x_1q3($x_1pi) { 
$x_r = " <span id='newFld'><select name='newFld'>"; 
$x_242 = ($x_1pi[WME_CURRENT_FOLDER]['type'] == KMS_FMAIL ? x_1dr::x_1dx('prevFolderMail') : x_1dr::x_1dx('prevFolderContact')); 
foreach ($x_1pi as $x_1rn) { 
if ($x_1rn['type'] != $x_1pi[WME_CURRENT_FOLDER]['type']) continue; 
if ($x_1rn['rights'] == "R") continue; 
$x_r .= "<option" . ($x_242 == $x_1rn['name'] ? " selected" : "") . " value='" . x_1b8($x_1rn['name']) . "'>" . $x_1rn['nameLocal'] . "</option>"; 
} 
print $x_r; 
$x_f6 = ($x_1pi[WME_CURRENT_FOLDER]['rights'] != "R" ? "detailMove" : "detailCopy"); 
?>
</select>
</span><input id='ok' name='<?php print $x_f6?>' type='submit' value='<kerio:text id='common-ok'/>'>
</td>
</tr>
</table><?php
} 
function x_1sg($x_1pi) { 
$x_h = kerio('KMS::UserInfo'); 
$x_1so = kerio('KMS::FolderStore'); 
$x_23g = $x_1so->getSharedFolderMappings(); 
$x_23h = $x_1sf = ""; 
foreach ($x_23g as $x_243) { 
if (($x_1p3 = substr($x_243, 0, strpos($x_243, "/"))) != $x_23h) $x_1sf['users'][] = $x_23g[] = $x_23h = $x_1p3; 
} 
foreach ($x_1pi as $x_1rn) { 
$x_1sf[$x_1rn['name']] = (in_array(substr(strstr($x_1rn['name'], "/"), 1), $x_23g) ? WME_SUBSCRIBED_FOLDER : WME_MY_FOLDER); 
} 
return $x_1sf; 
} 
function x_1sh($x_1pi, $x_1sf) { 
$x_h = kerio('KMS::UserInfo'); 
$x_19n = $x_h->getUserName(); 
$x_244 = (x_1dr::x_1dx('pda') == 0 ? "&nbsp;" : ""); 
?>
<table cellspacing='0' cellpadding='2' border='1' width='100%' class='folderTable' id='folderTable'>
<?php if (x_1dr::x_1dx('pda') == 0) :?>
<tr class='head'>
<td width='60%'><kerio:text id='common-folder'/></td>
<td width='1%'><kerio:text id='contact-list-items'/></td>
<td width='1%'><kerio:text id='express-action'/></td>
<td><kerio:text id='express-sharing'/></td>
</tr>
<tr>
<td nowrap><img src='../webmail/img/user.gif' width='16' height='16' alt='*' title=''> <a href='quota.php' class='folder'>
<?php
print (mb_strlen($x_19n) > USERNAME_LENGTH + 3 ? "<span title='" . x_1b8($x_19n) . "'>" . mb_substr($x_19n, 0, USERNAME_LENGTH) . "...</span>" : $x_19n); 
?>
</a></td>
<td align='right'>&nbsp;</td>
<td><a href='folder.php?goto=folderCreate&root=1'><kerio:text id='express-new-folder'/></a></td>
<td nowrap><a href='folder.php?goto=folderSubscribe'><kerio:text id='express-subscribe'/></a></td>
</tr>
<?php else: ?>
<tr>
<td width='1%'><img src='../webmail/img/user.gif' width='16' height='16' alt='*' title=''></td>
<td>
<a href='quota.php' class='folder'>
<?php
print (mb_strlen($x_19n) > PDA_USERNAME_LENGTH + 3 ? mb_substr($x_19n, 0, PDA_USERNAME_LENGTH) . "..." : $x_19n); 
?>
</a><br>
<a href='folder.php?goto=folderCreate&root=1'><kerio:text id='express-new-folder'/></a> - <a href='folder.php?goto=folderSubscribe'><kerio:text id='express-subscribe'/>
</td>
</tr>
<?php endif; ?>
<?php
$x_r = ""; 
$x_245 = (x_1dr::x_1dx('pda') == 0 ? 2 : 1); 
foreach ($x_1pi as $x_a => $x_1rn) { 
$x_166 = ""; 
if ($x_1rn['type'] != WME_NOT_SELECTABLE && $x_1rn['type'] != WME_NOT_ACCESSIBLE) { 
switch ($x_1rn['type']) { 
case KMS_FMAIL: 
$x_23x = (strstr($x_1rn['name'], "/") == "/" . FLD_INBOX ? "fmail_yellow" : (strstr($x_1rn['name'], "/") == "/" . FLD_TRASH ? "ftrash" : "fmail")); 
break; 
case KMS_FCONTACT: 
$x_23x = "fcontact"; 
break; 
default: 
$x_23x = "folder"; 
break; 
} 
if ($x_1rn['rights'] == "A" || $x_1rn['rights'] == "S") { 
$x_f6 = "<a href='folder.php?goto=folderCreate&fld=" . urlencode($x_1rn['name']) . "'><kerio:text id='express-new-subfolder'/></a>"; 
if (!x_1ic($x_1rn['name'], $x_1sf[$x_1rn['name']])) { 
$x_f6 .= 
" - <a href='folder.php?goto=folderRename&fld=" . urlencode($x_1rn['name']) . "'><kerio:text id='express-rename'/></a>" . 
" - <a href='folder.php?goto=folderMove&fld=" . urlencode($x_1rn['name']) . "'><kerio:text id='express-move'/></a>" . 
" - <a href='folder.php?goto=folderDelete&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&fld=" . urlencode($x_1rn['name']) . "&fldType=" . $x_1rn['type'] . "' name='del'><kerio:text id='express-delete'/></a>"; 
} 
$x_246 = ($x_1sf[$x_1rn['name']] ? "<a href='folder.php?goto=folderUnsubscribe&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&fld=" . urlencode($x_1rn['name']) . "' name='unsub2'><kerio:text id='express-unsubscribe'/></a> - " : ""); 
$x_246 .= "<a href='folder.php?goto=folderSharing&fld=" . urlencode($x_1rn['name']) . "'><kerio:text id='express-access-rights'/></a>"; 
} 
else { 
$x_f6 = $x_244; 
$x_246 = ($x_1sf[$x_1rn['name']] ? "<a href='folder.php?goto=folderUnsubscribe&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&fld=" . urlencode($x_1rn['name']) . "' name='unsub2'><kerio:text id='express-unsubscribe'/></a> - " : ""); 
$x_246 .= (strpos(strstr($x_1rn['name'], "/"), "/" . FLD_PUBLIC) !== false || 1? 
"<a href='folder.php?goto=folderSharing&fld=" . urlencode($x_1rn['name']) . "'><kerio:text id='express-access-rights'/></a>" : 
$x_244); 
} 
$x_166 = "row" . $x_245; 
} 
else { 
$x_23x = ($x_1rn['type'] == WME_NOT_SELECTABLE ? "folder" : "folder_gray"); 
$x_f6 = ($x_1rn['rights'] == "A" && ($x_1rn['name'] == "~" . $x_19n . "/" . FLD_PUBLIC || $x_1rn['name'] == "~" . $x_19n . "/" . FLD_ARCHIVE) ? 
"<a href='folder.php?goto=folderCreate&fld=" . urlencode($x_1rn['name']) . "'><kerio:text id='express-new-subfolder'/></a>" : 
$x_244); 
if ($x_1sf[$x_1rn['name']]) { 
$x_166 = "row" . $x_245; 
$x_246 = "<a href='folder.php?goto=folderUnsubscribe&x_1p9=" . x_1dr::x_1dx('x_1p9') . "&fld=" . urlencode($x_1rn['name']) . 
($x_1rn['type'] == WME_NOT_SELECTABLE ? "&all=1' name='unsub'" : "' name='unsub2'") . 
"><kerio:text id='express-unsubscribe'/></a>"; 
} 
else { 
$x_246 = (1 && ($x_1rn['name'] == "~" . $x_19n . "/" . FLD_PUBLIC || $x_1rn['name'] == "~" . $x_19n . "/" . FLD_ARCHIVE) ? 
"<a href='folder.php?goto=folderSharing&fld=" . urlencode($x_1rn['name']) . "'><kerio:text id='express-access-rights'/></a>" : 
$x_244); 
} 
} 
if ($x_a === WME_CURRENT_FOLDER) { 
$x_1u4 = "<b class='actFolder'>"; $x_1u5 = "</b>"; 
} 
else { 
$x_1u4 = $x_1u5 = ""; 
} 
$x_1b3 = (x_1dr::x_1dx('pda') == 1 || $x_1rn['shortLast'] == $x_1rn['nameLast'] ? "" : " title='" . $x_1rn['nameLast'] . "'"); 
switch ($x_1rn['type']) { 
case KMS_FMAIL: 
$x_247 = "<a" . $x_1b3 . " href='browse.php?fld=" . urlencode($x_1rn['name']) . "' class='folder'" . ($x_166 ? " id='" . $x_166 . "'" : "") . ">"; $x_248 = "</a>"; 
break; 
case KMS_FCONTACT: 
$x_247 = "<a" . $x_1b3 . " href='contact.php?fld=" . urlencode($x_1rn['name']) . "' class='folder'" . ($x_166 ? " id='" . $x_166 . "'" : "") . ">"; $x_248 = "</a>"; 
break; 
default: 
if ($x_166 == "") { 
if ($x_1b3 == "") { 
$x_247 = ""; 
$x_248 = ""; 
} 
else { 
$x_247 = "<span" . $x_1b3 . ">"; 
$x_248 = "</span>"; 
} 
} 
else { 
$x_247 = "<span" . $x_1b3 . " id='" . $x_166 . "'>"; $x_248 = "</span>"; 
} 
break; 
} 
if (x_1dr::x_1dx('pda') == 0) { 
$x_r .= 
"<tr>" . 
"<td nowrap>" . 
"<img src='img/trpix.gif' width='" . ($x_1rn['subList'] * 16 + 16) . "' height='16'>" . 
"<img src='../webmail/img/" . $x_23x . ($x_1rn['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' alt=''> " . $x_1u4 . 
$x_247 . $x_1rn['shortLast'] . $x_248 . $x_1u5 . 
"</td>". 
"<td align='right'>" . (substr($x_1rn['nameLast'], 0, 1) == "~" || $x_1rn['type'] == WME_NOT_SELECTABLE || $x_1rn['type'] == WME_NOT_ACCESSIBLE ? "&nbsp;" : $x_1rn['total']) . "</td>" . 
"<td nowrap>" . $x_f6 . "</td>" . 
"<td nowrap>" . $x_246 . "</td>" . 
"</tr>"; 
} 
else { 
$x_r .= 
"<tr>" . 
"<td>" . "<img src='../webmail/img/" . $x_23x . ($x_1rn['rights'] == "S" ? "s" : "") . ".gif' width='16' height='16' alt=''>" . "</td>" . 
"<td>" . $x_1u4 . $x_247 . $x_1rn['nameLocal'] . $x_248 . $x_1u5 . "<br>" . $x_f6 . ($x_f6 != $x_244 && $x_246 != $x_244 ? " - " : "") . $x_246 . 
"</td>" . 
"</tr>"; 
} 
$x_245++; 
} 
print $x_r; ?>
</table><?php
} 
function x_1si($x_1u7, $x_249) { 
if ($x_249) { 
$x_r = "<kerio:text id='fld-new'/>"; 
$x_h = kerio('KMS::UserInfo'); 
$x_233 = "~" . $x_h->getUserName(); 
} 
else { 
$x_r = "<kerio:text id='express-create-folder'/> \"" . $x_1u7['nameLast'] . "\""; 
$x_233 = x_1b8($x_1u7['name']); 
} 
?>
<br><h4 class='h4_small'><?php print $x_r ?></h4><br>
<input type='hidden' name='actionn' value='folderCreate'>
<input type='hidden' name='srcFld'  value='<?php print $x_233 ?>'>
<table cellspacing='0' cellpadding='2' border='0'>
<?php if (x_1dr::x_1dx('pda') == 0): ?>
<tr>
<td nowrap><kerio:text id='fld-new-name'/>:</td><td><input type='text' name='newFld'></td>
<td nowrap><kerio:text id='fld-new-type'/>:</td>
<td colspan='99' width='100%'>
<select name='fldType'>
<option value='<?php print KMS_FMAIL ?>'><kerio:text id='fld-type-mail'/></option>
<option value='<?php print KMS_FCONTACT . "'" . ($x_1u7['type'] == KMS_FCONTACT ? "selected" : "") ?>><kerio:text id='fld-type-contact'/></option>


			</select>


		</td>


	</tr>





	<?php else: ?>





	<tr>


		<td nowrap><kerio:text id='fld-new-name'/>:</td><td width='100%'><input type='text' name='newFld' xclass='full'></td>


	</tr>


	<tr>


		<td nowrap><kerio:text id='fld-new-type'/>:</td>


		<td width='100%'>


			<select name='fldType'>


				<option value='<?php print KMS_FMAIL ?>'><kerio:text id='fld-type-mail'/></option>


				<option value='<?php print KMS_FCONTACT . "'" . ($x_1u7['type'] == KMS_FCONTACT ? "selected" : "") ?>><kerio:text id='fld-type-contact'/></option>


			</select>


		</td>


	</tr>





	<?php endif; ?>





	</table>


	<br>


	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 
 function x_1sj($x_1u7) { 
 
 ?>


	<br><h4 class='h4_small'><kerio:text id='express-rename-folder'/> "<?php print $x_1u7['nameLast']?>"</h4><br>





	<input type='hidden' name='actionn' value='folderRename'>


	<input type='hidden' name='srcFld'  value='<?php print x_1b8($x_1u7['name'])?>'>





	<table cellspacing='0' cellpadding='2' border='0'>


	<tr>


		<td nowrap><kerio:text id='fld-new-name'/>:</td><td><input type='text' name='newFld'></td>


	</tr>


	</table>


	<br>


	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 
 function x_1sk($x_1pi) { 
 
 $x_24a = $x_1pi[WME_CURRENT_FOLDER]['name']; 
 $x_24b = substr($x_24a, 0, strrpos($x_24a, "/")); 
 $x_r = ""; 
 
 foreach ($x_1pi as $x_a => $x_1rn) { 
 if ($x_a === WME_CURRENT_FOLDER) continue; 
 if ($x_1rn['rights'] == "R" || $x_1rn['rights'] == "E") continue; 
 if ($x_1rn['name'] == $x_24b || strpos($x_1rn['name'] . "/", $x_24a . "/") === 0) continue; 
 
 $x_r .= "<option value='" . x_1b8($x_1rn['name']) . "'>" . $x_1rn['nameLocal'] . "</option>"; 
 } 
 
 
 if ($x_1pi[WME_CURRENT_FOLDER]['subList'] != 0) { 
 
 $x_1yv = (x_1dr::x_1dx('pda') == 0 ? USERNAME_LENGTH : PDA_USERNAME_LENGTH); 
 
 $x_h = kerio('KMS::UserInfo'); 
 $x_19n = $x_h->getUserName(); 
 $x_r = 
 "<option value='~" . $x_19n . "'>" . 
 (mb_strlen($x_19n) > $x_1yv + 3 ? mb_substr($x_19n, 0, $x_1yv) . "..." : $x_19n) . 
 "</option>" . $x_r; 
 } 
 ?>


	<br><h4 class='h4_small'><kerio:text id='express-move-folder'/> "<?php print $x_1pi[WME_CURRENT_FOLDER]['nameLast']?>"</h4><br>





	<input type='hidden' name='actionn' value='folderMove'>


	<input type='hidden' name='srcFld'  value='<?php print x_1b8($x_1pi[WME_CURRENT_FOLDER]['name'])?>'>





	<table cellspacing='0' cellpadding='2' border='0'>


	<tr>


		<td nowrap><kerio:text id='express-target-folder'/>:</td><td><select name='newFld'><?php print $x_r?></select></td>


	</tr>


	</table>


	<br>


	<input type='submit' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 $x_24c = array( 
 LEVEL_ADMIN => "lrswicda", 
 LEVEL_EDITOR => "lrswid", 
 LEVEL_READER => "lr" 
 ); 
 
 $x_24d = array( 
 LEVEL_ADMIN => "<kerio:text id='fld-sharing-administrator'/>", 
 LEVEL_EDITOR => "<kerio:text id='fld-sharing-editor'/>", 
 LEVEL_READER => "<kerio:text id='fld-sharing-reader'/>" 
 ); 
 
 
 
 function x_24e($x_24f) { 
 foreach ($GLOBALS['x_24c'] as $x_24g => $x_1tp) { 
 $x_24h = true; 
 for ($x_1l = 0; $x_1l < strlen($x_1tp); $x_1l++) { 
 if (!strstr($x_24f, $x_1tp[$x_1l])) { 
 $x_24h = false; 
 } 
 } 
 if ($x_24h) return $x_24g; 
 } 
 } 
 
 
 
 
 function x_1sl($x_1u7) { 
 
 $x_1so = kerio('KMS::FolderStore'); 
 $x_1ly = $x_1so->getFolderAcl($x_1u7['name'], &$x_1p3); 
 
 $x_h = kerio('KMS::UserInfo'); 
 $x_19n = strtolower($x_h->getUserName()); 
 
 
 $x_24i = (strpos($x_1so->getFolderAclMyrights($x_1u7['name']), "a") !== false); 
 
 $x_1l = 0; $x_1pp = 0; 
 foreach ($x_1p3 as $x_1yf) { 
 $x_1p3[$x_1l]['rights'] = $GLOBALS['x_24d'][x_24e($x_1yf['rights'])]; 
 
 
 if (strtolower($x_1yf['name']) == $x_19n && strpos($x_1yf['rights'], "O") !== false) { 
 $x_1p3[$x_1l]['rights'] = ""; 
 $x_1pp--; 
 } 
 elseif (strpos($x_1yf['rights'], "a") !== false) { 
 
 
 if ($x_1u7['name'] == "~" . $x_19n . "/" . FLD_PUBLIC || $x_1u7['name'] == "~" . $x_19n . "/" . FLD_ARCHIVE) { 
 $x_1pp--; 
 } 
 } 
 $x_1l++; 
 } 
 $x_1pp += $x_1l; 
 
 
 $x_1l = 0; 
 foreach ($x_1p3 as $x_23s) { 
 
 
 if (substr($x_23s['name'], 0, 1) == "[") { 
 $x_1p3[$x_1l]['icon'] = "<img src='/webmail/img/usersg.gif' width='16' height='16' alt='G' title=''>"; 
 $x_1p3[$x_1l]['display'] = x_1b8(substr($x_23s['name'], 1, strlen($x_23s['name']) - 2)); 
 } 
 
 
 elseif (substr($x_23s['name'], 0, 9) == 'authuser@') { 
 $x_1p3[$x_1l]['icon'] = "<img src='/webmail/img/user_black.gif' width='16' height='16' alt=''>"; 
 $x_1p3[$x_1l]['display'] = '<kerio:text id="fld-sharing-domain-from"/> '. x_1b8(substr($x_23s['name'], 9)); 
 } 
 
 elseif ($x_23s['name'] == 'authuser') { 
 $x_1p3[$x_1l]['icon'] = "<img src='/webmail/img/user_black.gif' width='16' height='16' alt=''>"; 
 $x_1p3[$x_1l]['display'] = '<kerio:text id="fld-sharing-all"/>'; 
 } 
 
 elseif ($x_23s['name'] == 'anyone') { 
 $x_1p3[$x_1l]['icon'] = "<img src='/webmail/img/user_black.gif' width='16' height='16' alt=''>"; 
 $x_1p3[$x_1l]['display'] = '<kerio:text id="fld-sharing-anonymous"/>'; 
 } 
 
 
 else { 
 $x_1p3[$x_1l]['icon'] = "<img src='/webmail/img/userg.gif' width='16' height='16' alt=''>"; 
 $x_1p3[$x_1l]['display'] = x_1b8($x_23s['name']); 
 } 
 $x_1l++; 
 } 
 ?>





	<script type="text/javascript" src="funcFolder.js?v=<?php print SERVER_HASH?>"></script>


	<br><h4 class='h4_small'><kerio:text id='express-sharing-table'/> "<?php print $x_1u7['nameLast']?>"</h4><br>





	<?php

 if (!$x_24i) { 
 foreach ($x_1p3 as $x_23s) { 
 if ($x_23s['rights'] == "") continue; 
 $x_r .= "&nbsp;" . $x_23s['icon'] . "&nbsp;" . $x_23s['display'] . " (" . $x_23s['rights'] . ")<br>"; 
 } 
 print $x_r . "<br><input type='submit' name='cancel' value='<kerio:text id='common-back'/>'>"; 
 return; 
 } 
 
 $x_1y = ($x_1pp > 0 ? "radio" : "hidden"); 
 ?>





	<input type='hidden' name='fld' value='<?php print x_1b8($x_1u7['name'])?>'>





	<table cellspacing='0' cellpadding='2' border='0'>





	<?php if (x_1dr::x_1dx('pda') == 0) :?>





	<tr>


		<td width='21'><input type='<?php print $x_1y ?>' name='actionn' value='sharingAdd' id='add' checked></td>


		<td nowrap><label for='add'><kerio:text id='express-sharing-add'/></label></td>


		<td>


			<select name='userGroup'>


				<option value='U'><kerio:text id='fld-sharing-user'/></option>


				<option value='G'><kerio:text id='fld-sharing-group'/></option>


				<option value='D'><kerio:text id='fld-sharing-domain'/></option>


				<option value='A'><kerio:text id='fld-sharing-all'/></option>


				<option value='X'><kerio:text id='fld-sharing-anonymous'/></option>


			</select>


			<input type='text' name='user1' size='15'>


		</td>


		<td>


			<kerio:text id='express-sharing-rights'/>


		</td>


		<td>


			<select name='rights'>


				<option value='A'><kerio:text id='fld-sharing-administrator'/></option>


				<option value='E'><kerio:text id='fld-sharing-editor'/></option>


				<option value='R' selected><kerio:text id='fld-sharing-reader'/></option>


			</select>


		</td>


	</tr>





	<? else: ?>





	<tr>


		<td width='21'><input type='<?php print $x_1y ?>' name='actionn' value='sharingAdd' id='add' checked></td>


		<td nowrap><label for='add'><kerio:text id='express-sharing-add'/></label></td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<select name='userGroup'>


				<option value='U'><kerio:text id='fld-sharing-user'/></option>


				<option value='G'><kerio:text id='fld-sharing-group'/></option>


				<option value='D'><kerio:text id='fld-sharing-domain'/></option>


				<option value='A'><kerio:text id='fld-sharing-all'/></option>


				<option value='X'><kerio:text id='fld-sharing-anonymous'/></option>


			</select>


		</td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<input type='text' name='user1' size='15'>


		</td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<kerio:text id='express-sharing-rights'/>


		</td>


	</tr>


	<tr>


		<td>&nbsp;</td>


		<td>


			<select name='rights'>


				<option value='A'><kerio:text id='fld-sharing-administrator'/></option>


				<option value='E'><kerio:text id='fld-sharing-editor'/></option>


				<option value='R' selected><kerio:text id='fld-sharing-reader'/></option>


			</select>


		</td>


	</tr>








	<? endif; ?>





	<?php if ($x_1pp > 0): ?>





	<tr>


		<td><input type='radio' name='actionn' value='sharingRemove' id='remove'></td>


		<td nowrap colspan='4'><label for='remove'><kerio:text id='express-sharing-remove'/></label></td>


	</tr>





	<?php

 $x_r = ""; $x_1l = 1; 
 
 foreach ($x_1p3 as $x_23s) { 
 if ($x_23s['rights'] == "") continue; 
 $x_r .= 
 '<tr><td>&nbsp;</td><td colspan="4"><input ' . 
 'type="checkbox" name="user2[]" value="' . x_1b8($x_23s['name']) . '" id="x' . $x_1l . '">' . 
 '<label for="x' . $x_1l . '">&nbsp;' . $x_23s['icon'] . '&nbsp;' . $x_23s['display'] . ' (' . $x_23s['rights'] . ')</label>' . 
 '</td></tr>'; 
 $x_1l++; 
 } 
 print $x_r; 
 ?>





	<?php endif; ?>





	</table>


	<br>


	<input type='submit' name='ok' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><p>


	<?php

 } 
 
 
 
 
 function x_1sm() { 
 
 ?>


	<br><h4 class='h4_small'><kerio:text id='express-sharing-subscribe'/>:</h4><br>





	<input type='hidden' name='actionn' value='folderSubscribe'>





	<table cellspacing='0' cellpadding='2' border='0'>


	<tr>


		<td><input type='text' name='user' size='15'></td>


	</tr>


	</table>


	<br>


	<input type='submit' name='ok' value='<kerio:text id='common-ok'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-back'/>'><?php

 } 
 
 
 
 
 function x_1sn($x_f6, $x_1u7) { 
 
 switch ($x_f6) { 
 case "folderDelete": 
 $x_1w7 = "<kerio:text id='fld-really-delete'/>"; 
 $x_z = $x_1u7['nameLast']; 
 break; 
 
 case "folderUnsubscribeAll": 
 $x_1w7 = "<kerio:text id='express-sharing-unsubscribe'/>"; 
 $x_z = substr($x_1u7['nameLast'], 1); 
 
 print "<input type='hidden' name='all' value='1'>"; 
 $x_f6 = "folderUnsubscribe"; 
 break; 
 
 case "folderUnsubscribe": 
 $x_1w7 = "<kerio:text id='fld-really-disconnect'/>"; 
 $x_z = $x_1u7['nameLast']; 
 break; 
 } 
 
 print "<br><h4>" . $x_1w7 . " \"" . $x_z . "\"?</h4><br>"; 
 ?>





	<input type='hidden' name='actionn' value='<?php print $x_f6?>'>


	<input type='submit' value='<kerio:text id='common-yes'/>'>&nbsp;<input type='submit' name='cancel' value='<kerio:text id='common-no'/>'>


	<?php

 } 
 ?>